- name: Install nginx
  apt:
    name: nginx
    state: latest

- name: Install certbot to manage letsencrypt certificates
  apt:
    name: certbot
    state: latest
    
- name: Copy nginx config in place
  copy:
    src: nginx.conf
    dest: /etc/nginx/nginx.conf
  notify: Restart nginx

- name: Copy nginx nodejs snippet
  copy:
    src: nodejs_proxy_params
    dest: /etc/nginx/nodejs_proxy_params
  notify: Restart nginx

- name: Copy nginx nodejs upstream config
  copy:
    src: nodejs_upstream.conf
    dest: /etc/nginx/conf.d/nodejs_upstream.conf
  notify: Restart nginx

- name: Create server block for all domains for letsencrypt validation and HTTPS redirect
  copy:
    src: nginx-letsencrypt-site.conf
    dest: /etc/nginx/sites-available/nginx-letsencrypt-site.conf
  notify: Restart nginx

- name: Enable letsencrypt/HTTPS redirect server block
  file:
    src: /etc/nginx/sites-available/nginx-letsencrypt-site.conf
    dest: /etc/nginx/sites-enabled/nginx-letsencrypt-site.conf
    state: link
  notify: Restart nginx

- name: Disable default website
  file:
    path: /etc/nginx/sites-enabled/default
    state: absent
  notify: Restart nginx

- name: Generate dhparams
  openssl_dhparam:
    path: /etc/ssl/certs/dhparam.pem
    size: 4096

- name: Setup redirect server blocks
  template:
    src: nginx-redirects.conf
    dest: /etc/nginx/sites-available/redirects.conf
  notify: reload nginx

- name: Enable redirect server blocks
  file:
    src: /etc/nginx/sites-available/redirects.conf
    dest: /etc/nginx/sites-enabled/redirects.conf
    state: link
  notify: reload nginx